diff --git a/src/backend/access/spgist/spgvacuum.c b/src/backend/access/spgist/spgvacuum.c
index 6b7117b56b2..77947723d04 100644
--- a/src/backend/access/spgist/spgvacuum.c
+++ b/src/backend/access/spgist/spgvacuum.c
@@ -127,7 +127,7 @@ vacuumLeafPage(spgBulkDeleteState *bds, Relation index, Buffer buffer,
 			   bool forPending)
 {
 	Page		page = BufferGetPage(buffer);
-	spgxlogVacuumLeaf xlrec;
+	spgxlogVacuumLeaf xlrec = {0};
 	OffsetNumber toDead[MaxIndexTuplesPerPage];
 	OffsetNumber toPlaceholder[MaxIndexTuplesPerPage];
 	OffsetNumber moveSrc[MaxIndexTuplesPerPage];
@@ -409,7 +409,7 @@ static void
 vacuumLeafRoot(spgBulkDeleteState *bds, Relation index, Buffer buffer)
 {
 	Page		page = BufferGetPage(buffer);
-	spgxlogVacuumRoot xlrec;
+	spgxlogVacuumRoot xlrec = {0};
 	OffsetNumber toDelete[MaxIndexTuplesPerPage];
 	OffsetNumber i,
 				max = PageGetMaxOffsetNumber(page);
@@ -502,7 +502,7 @@ vacuumRedirectAndPlaceholder(Relation index, Relation heaprel, Buffer buffer)
 	bool		hasUpdate = false;
 	OffsetNumber itemToPlaceholder[MaxIndexTuplesPerPage];
 	OffsetNumber itemnos[MaxIndexTuplesPerPage];
-	spgxlogVacuumRedirect xlrec;
+	spgxlogVacuumRedirect xlrec = {0};
 	GlobalVisState *vistest;
 
 	xlrec.isCatalogRel = RelationIsAccessibleInLogicalDecoding(heaprel);
diff --git a/src/backend/access/spgist/spgxlog.c b/src/backend/access/spgist/spgxlog.c
index 55e8066a77b..b2d258f6c28 100644
--- a/src/backend/access/spgist/spgxlog.c
+++ b/src/backend/access/spgist/spgxlog.c
@@ -77,7 +77,7 @@ spgRedoAddLeaf(XLogReaderState *record)
 	char	   *ptr = XLogRecGetData(record);
 	spgxlogAddLeaf *xldata = (spgxlogAddLeaf *) ptr;
 	char	   *leafTuple;
-	SpGistLeafTupleData leafTupleHdr;
+	SpGistLeafTupleData leafTupleHdr = {0};
 	Buffer		buffer;
 	Page		page;
 	XLogRedoAction action;
@@ -221,7 +221,7 @@ spgRedoMoveLeafs(XLogReaderState *record)
 		for (i = 0; i < nInsert; i++)
 		{
 			char	   *leafTuple;
-			SpGistLeafTupleData leafTupleHdr;
+			SpGistLeafTupleData leafTupleHdr = {0};
 
 			/*
 			 * the tuples are not aligned, so must copy to access the size
@@ -285,7 +285,7 @@ spgRedoAddNode(XLogReaderState *record)
 	char	   *ptr = XLogRecGetData(record);
 	spgxlogAddNode *xldata = (spgxlogAddNode *) ptr;
 	char	   *innerTuple;
-	SpGistInnerTupleData innerTupleHdr;
+	SpGistInnerTupleData innerTupleHdr = {0};
 	SpGistState state;
 	Buffer		buffer;
 	Page		page;
@@ -451,9 +451,9 @@ spgRedoSplitTuple(XLogReaderState *record)
 	char	   *ptr = XLogRecGetData(record);
 	spgxlogSplitTuple *xldata = (spgxlogSplitTuple *) ptr;
 	char	   *prefixTuple;
-	SpGistInnerTupleData prefixTupleHdr;
+	SpGistInnerTupleData prefixTupleHdr = {0};
 	char	   *postfixTuple;
-	SpGistInnerTupleData postfixTupleHdr;
+	SpGistInnerTupleData postfixTupleHdr = {0};
 	Buffer		buffer;
 	Page		page;
 	XLogRedoAction action;
@@ -526,7 +526,7 @@ spgRedoPickSplit(XLogReaderState *record)
 	char	   *ptr = XLogRecGetData(record);
 	spgxlogPickSplit *xldata = (spgxlogPickSplit *) ptr;
 	char	   *innerTuple;
-	SpGistInnerTupleData innerTupleHdr;
+	SpGistInnerTupleData innerTupleHdr = {0};
 	SpGistState state;
 	OffsetNumber *toDelete;
 	OffsetNumber *toInsert;
@@ -645,7 +645,7 @@ spgRedoPickSplit(XLogReaderState *record)
 	for (i = 0; i < xldata->nInsert; i++)
 	{
 		char	   *leafTuple;
-		SpGistLeafTupleData leafTupleHdr;
+		SpGistLeafTupleData leafTupleHdr = {0};
 
 		/* the tuples are not aligned, so must copy to access the size field. */
 		leafTuple = ptr;
diff --git a/src/backend/access/transam/clog.c b/src/backend/access/transam/clog.c
index b5c38bbb162..d62d22ef444 100644
--- a/src/backend/access/transam/clog.c
+++ b/src/backend/access/transam/clog.c
@@ -1044,7 +1044,7 @@ static void
 WriteTruncateXlogRec(int64 pageno, TransactionId oldestXact, Oid oldestXactDb)
 {
 	XLogRecPtr	recptr;
-	xl_clog_truncate xlrec;
+	xl_clog_truncate xlrec = {0};
 
 	xlrec.pageno = pageno;
 	xlrec.oldestXact = oldestXact;
@@ -1076,7 +1076,7 @@ clog_redo(XLogReaderState *record)
 	}
 	else if (info == CLOG_TRUNCATE)
 	{
-		xl_clog_truncate xlrec;
+		xl_clog_truncate xlrec = {0};
 
 		memcpy(&xlrec, XLogRecGetData(record), sizeof(xl_clog_truncate));
 
diff --git a/src/backend/access/transam/commit_ts.c b/src/backend/access/transam/commit_ts.c
index 6fa2178f1dd..55349042ed7 100644
--- a/src/backend/access/transam/commit_ts.c
+++ b/src/backend/access/transam/commit_ts.c
@@ -966,7 +966,7 @@ CommitTsPagePrecedes(int64 page1, int64 page2)
 static void
 WriteTruncateXlogRec(int64 pageno, TransactionId oldestXid)
 {
-	xl_commit_ts_truncate xlrec;
+	xl_commit_ts_truncate xlrec = {0};
 
 	xlrec.pageno = pageno;
 	xlrec.oldestXid = oldestXid;
diff --git a/src/backend/access/transam/multixact.c b/src/backend/access/transam/multixact.c
index 90ec87d9dd6..a005bbed209 100644
--- a/src/backend/access/transam/multixact.c
+++ b/src/backend/access/transam/multixact.c
@@ -657,7 +657,7 @@ MultiXactIdCreateFromMembers(int nmembers, MultiXactMember *members)
 {
 	MultiXactId multi;
 	MultiXactOffset offset;
-	xl_multixact_create xlrec;
+	xl_multixact_create xlrec = {0};
 
 	debug_elog3(DEBUG2, "Create: %s",
 				mxid_to_string(InvalidMultiXactId, nmembers, members));
@@ -728,7 +728,7 @@ MultiXactIdCreateFromMembers(int nmembers, MultiXactMember *members)
 	 */
 	XLogBeginInsert();
 	XLogRegisterData(&xlrec, SizeOfMultiXactCreate);
-	XLogRegisterData(members, nmembers * sizeof(MultiXactMember));
+	XLogRegisterData((char *) members, nmembers * sizeof(MultiXactMember));
 
 	(void) XLogInsert(RM_MULTIXACT_ID, XLOG_MULTIXACT_CREATE_ID);
 
@@ -2796,7 +2796,7 @@ WriteMTruncateXlogRec(Oid oldestMultiDB,
 					  MultiXactOffset oldestOffset)
 {
 	XLogRecPtr	recptr;
-	xl_multixact_truncate xlrec;
+	xl_multixact_truncate xlrec = {0};
 
 	xlrec.oldestMultiDB = oldestMultiDB;
 	xlrec.oldestMulti = oldestMulti;
@@ -2864,7 +2864,7 @@ multixact_redo(XLogReaderState *record)
 	}
 	else if (info == XLOG_MULTIXACT_TRUNCATE_ID)
 	{
-		xl_multixact_truncate xlrec;
+		xl_multixact_truncate xlrec = {0};
 		int64		pageno;
 
 		memcpy(&xlrec, XLogRecGetData(record),
diff --git a/src/backend/access/transam/xact.c b/src/backend/access/transam/xact.c
index eba4f063168..df72a2566e6 100644
--- a/src/backend/access/transam/xact.c
+++ b/src/backend/access/transam/xact.c
@@ -761,7 +761,7 @@ AssignTransactionId(TransactionState s)
 		if (nUnreportedXids >= PGPROC_MAX_CACHED_SUBXIDS ||
 			log_unknown_top)
 		{
-			xl_xact_assignment xlrec;
+			xl_xact_assignment xlrec = {0};
 
 			/*
 			 * xtop is always set by now because we recurse up transaction
@@ -5842,15 +5842,15 @@ XactLogCommitRecord(TimestampTz commit_time,
 					int xactflags, TransactionId twophase_xid,
 					const char *twophase_gid)
 {
-	xl_xact_commit xlrec;
-	xl_xact_xinfo xl_xinfo;
-	xl_xact_dbinfo xl_dbinfo;
-	xl_xact_subxacts xl_subxacts;
-	xl_xact_relfilelocators xl_relfilelocators;
-	xl_xact_stats_items xl_dropped_stats;
-	xl_xact_invals xl_invals;
-	xl_xact_twophase xl_twophase;
-	xl_xact_origin xl_origin;
+	xl_xact_commit xlrec = {0};
+	xl_xact_xinfo xl_xinfo = {0};
+	xl_xact_dbinfo xl_dbinfo = {0};
+	xl_xact_subxacts xl_subxacts = {0};
+	xl_xact_relfilelocators xl_relfilelocators = {0};
+	xl_xact_stats_items xl_dropped_stats = {0};
+	xl_xact_invals xl_invals = {0};
+	xl_xact_twophase xl_twophase = {0};
+	xl_xact_origin xl_origin = {0};
 	uint8		info;
 
 	Assert(CritSectionCount > 0);
@@ -5963,7 +5963,7 @@ XactLogCommitRecord(TimestampTz commit_time,
 	{
 		XLogRegisterData(&xl_relfilelocators,
 						 MinSizeOfXactRelfileLocators);
-		XLogRegisterData(rels,
+		XLogRegisterData((char *) rels,
 						 nrels * sizeof(RelFileLocator));
 	}
 
@@ -5971,14 +5971,14 @@ XactLogCommitRecord(TimestampTz commit_time,
 	{
 		XLogRegisterData(&xl_dropped_stats,
 						 MinSizeOfXactStatsItems);
-		XLogRegisterData(droppedstats,
+		XLogRegisterData((char *) droppedstats,
 						 ndroppedstats * sizeof(xl_xact_stats_item));
 	}
 
 	if (xl_xinfo.xinfo & XACT_XINFO_HAS_INVALS)
 	{
 		XLogRegisterData(&xl_invals, MinSizeOfXactInvals);
-		XLogRegisterData(msgs,
+		XLogRegisterData((char *) msgs,
 						 nmsgs * sizeof(SharedInvalidationMessage));
 	}
 
@@ -6012,14 +6012,14 @@ XactLogAbortRecord(TimestampTz abort_time,
 				   int xactflags, TransactionId twophase_xid,
 				   const char *twophase_gid)
 {
-	xl_xact_abort xlrec;
-	xl_xact_xinfo xl_xinfo;
-	xl_xact_subxacts xl_subxacts;
-	xl_xact_relfilelocators xl_relfilelocators;
-	xl_xact_stats_items xl_dropped_stats;
-	xl_xact_twophase xl_twophase;
-	xl_xact_dbinfo xl_dbinfo;
-	xl_xact_origin xl_origin;
+	xl_xact_abort xlrec = {0};
+	xl_xact_xinfo xl_xinfo = {0};
+	xl_xact_subxacts xl_subxacts = {0};
+	xl_xact_relfilelocators xl_relfilelocators = {0};
+	xl_xact_stats_items xl_dropped_stats = {0};
+	xl_xact_twophase xl_twophase = {0};
+	xl_xact_dbinfo xl_dbinfo = {0};
+	xl_xact_origin xl_origin = {0};
 
 	uint8		info;
 
@@ -6116,7 +6116,7 @@ XactLogAbortRecord(TimestampTz abort_time,
 	{
 		XLogRegisterData(&xl_relfilelocators,
 						 MinSizeOfXactRelfileLocators);
-		XLogRegisterData(rels,
+		XLogRegisterData((char *) rels,
 						 nrels * sizeof(RelFileLocator));
 	}
 
@@ -6124,7 +6124,7 @@ XactLogAbortRecord(TimestampTz abort_time,
 	{
 		XLogRegisterData(&xl_dropped_stats,
 						 MinSizeOfXactStatsItems);
-		XLogRegisterData(droppedstats,
+		XLogRegisterData((char *) droppedstats,
 						 ndroppedstats * sizeof(xl_xact_stats_item));
 	}
 
diff --git a/src/backend/access/transam/xlog.c b/src/backend/access/transam/xlog.c
index 13cce9b49f1..45832a59e1d 100644
--- a/src/backend/access/transam/xlog.c
+++ b/src/backend/access/transam/xlog.c
@@ -5125,7 +5125,7 @@ XLOGShmemInit(void)
 void
 BootStrapXLOG(uint32 data_checksum_version)
 {
-	CheckPoint	checkPoint;
+	CheckPoint	checkPoint = {0};
 	PGAlignedXLogBlock buffer;
 	XLogPageHeader page;
 	XLogLongPageHeader longpage;
@@ -5207,6 +5207,7 @@ BootStrapXLOG(uint32 data_checksum_version)
 	/* Insert the initial checkpoint record */
 	recptr = ((char *) page + SizeOfXLogLongPHD);
 	record = (XLogRecord *) recptr;
+	memset(record, 0, SizeOfXLogRecord);
 	record->xl_prev = InvalidXLogRecPtr;
 	record->xl_xid = InvalidTransactionId;
 	record->xl_tot_len = SizeOfXLogRecord + SizeOfXLogRecordDataHeaderShort + sizeof(checkPoint);
@@ -5517,7 +5518,7 @@ void
 StartupXLOG(void)
 {
 	XLogCtlInsert *Insert;
-	CheckPoint	checkPoint;
+	CheckPoint	checkPoint = {0};
 	bool		wasShutdown;
 	bool		didCrash;
 	bool		haveTblspcMap;
@@ -7025,7 +7026,7 @@ bool
 CreateCheckPoint(int flags)
 {
 	bool		shutdown;
-	CheckPoint	checkPoint;
+	CheckPoint	checkPoint = {0};
 	XLogRecPtr	recptr;
 	XLogSegNo	_logSegNo;
 	XLogCtlInsert *Insert = &XLogCtl->Insert;
@@ -7515,7 +7516,7 @@ CreateCheckPoint(int flags)
 static void
 CreateEndOfRecoveryRecord(void)
 {
-	xl_end_of_recovery xlrec;
+	xl_end_of_recovery xlrec = {0};
 	XLogRecPtr	recptr;
 
 	/* sanity check */
@@ -7581,7 +7582,7 @@ static XLogRecPtr
 CreateOverwriteContrecordRecord(XLogRecPtr aborted_lsn, XLogRecPtr pagePtr,
 								TimeLineID newTLI)
 {
-	xl_overwrite_contrecord xlrec;
+	xl_overwrite_contrecord xlrec = {0};
 	XLogRecPtr	recptr;
 	XLogPageHeader pagehdr;
 	XLogRecPtr	startPos;
@@ -7732,7 +7733,7 @@ CreateRestartPoint(int flags)
 {
 	XLogRecPtr	lastCheckPointRecPtr;
 	XLogRecPtr	lastCheckPointEndPtr;
-	CheckPoint	lastCheckPoint;
+	CheckPoint	lastCheckPoint = {0};
 	XLogRecPtr	PriorRedoPtr;
 	XLogRecPtr	receivePtr;
 	XLogRecPtr	replayPtr;
@@ -8223,7 +8224,7 @@ XLogRecPtr
 XLogRestorePoint(const char *rpName)
 {
 	XLogRecPtr	RecPtr;
-	xl_restore_point xlrec;
+	xl_restore_point xlrec = {0};
 
 	xlrec.rp_time = GetCurrentTimestamp();
 	strlcpy(xlrec.rp_name, rpName, MAXFNAMELEN);
@@ -8265,7 +8266,7 @@ XLogReportParameters(void)
 		 */
 		if (wal_level != ControlFile->wal_level || XLogIsNeeded())
 		{
-			xl_parameter_change xlrec;
+			xl_parameter_change xlrec = {0};
 			XLogRecPtr	recptr;
 
 			xlrec.MaxConnections = MaxConnections;
@@ -8408,7 +8409,7 @@ xlog_redo(XLogReaderState *record)
 	}
 	else if (info == XLOG_CHECKPOINT_SHUTDOWN)
 	{
-		CheckPoint	checkPoint;
+		CheckPoint	checkPoint = {0};
 		TimeLineID	replayTLI;
 
 		memcpy(&checkPoint, XLogRecGetData(record), sizeof(CheckPoint));
@@ -8509,7 +8510,7 @@ xlog_redo(XLogReaderState *record)
 	}
 	else if (info == XLOG_CHECKPOINT_ONLINE)
 	{
-		CheckPoint	checkPoint;
+		CheckPoint	checkPoint = {0};
 		TimeLineID	replayTLI;
 
 		memcpy(&checkPoint, XLogRecGetData(record), sizeof(CheckPoint));
@@ -8574,7 +8575,7 @@ xlog_redo(XLogReaderState *record)
 	}
 	else if (info == XLOG_END_OF_RECOVERY)
 	{
-		xl_end_of_recovery xlrec;
+		xl_end_of_recovery xlrec = {0};
 		TimeLineID	replayTLI;
 
 		memcpy(&xlrec, XLogRecGetData(record), sizeof(xl_end_of_recovery));
@@ -8647,7 +8648,7 @@ xlog_redo(XLogReaderState *record)
 	}
 	else if (info == XLOG_PARAMETER_CHANGE)
 	{
-		xl_parameter_change xlrec;
+		xl_parameter_change xlrec = {0};
 
 		/* Update our copy of the parameters in pg_control */
 		memcpy(&xlrec, XLogRecGetData(record), sizeof(xl_parameter_change));
diff --git a/src/backend/access/transam/xloginsert.c b/src/backend/access/transam/xloginsert.c
index a9a1678acc9..d1b6fbea81c 100644
--- a/src/backend/access/transam/xloginsert.c
+++ b/src/backend/access/transam/xloginsert.c
@@ -584,6 +584,7 @@ XLogRecordAssemble(RmgrId rmid, uint8 info,
 
 	/* The record begins with the fixed-size header */
 	rechdr = (XLogRecord *) scratch;
+	memset(rechdr, 0, SizeOfXLogRecord);
 	scratch += SizeOfXLogRecord;
 
 	hdr_rdt.next = NULL;
@@ -610,8 +611,8 @@ XLogRecordAssemble(RmgrId rmid, uint8 info,
 		registered_buffer *regbuf = &registered_buffers[block_id];
 		bool		needs_backup;
 		bool		needs_data;
-		XLogRecordBlockHeader bkpb;
-		XLogRecordBlockImageHeader bimg;
+		XLogRecordBlockHeader bkpb = {0};
+		XLogRecordBlockImageHeader bimg = {0};
 		XLogRecordBlockCompressHeader cbimg = {0};
 		bool		samerel;
 		bool		is_compressed = false;
diff --git a/src/backend/access/transam/xlogreader.c b/src/backend/access/transam/xlogreader.c
index 03ada8aa0c5..6c743f8c98d 100644
--- a/src/backend/access/transam/xlogreader.c
+++ b/src/backend/access/transam/xlogreader.c
@@ -1806,9 +1806,12 @@ DecodeXLogRecord(XLogReaderState *state,
 
 			if (blk->has_image)
 			{
+				uint8		bimg_pad;
+
 				COPY_HEADER_FIELD(&blk->bimg_len, sizeof(uint16));
 				COPY_HEADER_FIELD(&blk->hole_offset, sizeof(uint16));
 				COPY_HEADER_FIELD(&blk->bimg_info, sizeof(uint8));
+				COPY_HEADER_FIELD(&bimg_pad, sizeof(uint8));
 
 				blk->apply_image = ((blk->bimg_info & BKPIMAGE_APPLY) != 0);
 
diff --git a/src/backend/access/transam/xlogrecovery.c b/src/backend/access/transam/xlogrecovery.c
index ecd66fd86a4..75bd50ec278 100644
--- a/src/backend/access/transam/xlogrecovery.c
+++ b/src/backend/access/transam/xlogrecovery.c
@@ -526,7 +526,7 @@ InitWalRecovery(ControlFileData *ControlFile, bool *wasShutdown_ptr,
 	DBState		dbstate_at_startup;
 	bool		haveTblspcMap = false;
 	bool		haveBackupLabel = false;
-	CheckPoint	checkPoint;
+	CheckPoint	checkPoint = {0};
 	bool		backupFromStandby = false;
 
 	dbstate_at_startup = ControlFile->state;
@@ -1971,7 +1971,7 @@ ApplyWalRecord(XLogReaderState *xlogreader, XLogRecord *record, TimeLineID *repl
 
 		if (info == XLOG_CHECKPOINT_SHUTDOWN)
 		{
-			CheckPoint	checkPoint;
+			CheckPoint	checkPoint = {0};
 
 			memcpy(&checkPoint, XLogRecGetData(xlogreader), sizeof(CheckPoint));
 			newReplayTLI = checkPoint.ThisTimeLineID;
@@ -1979,7 +1979,7 @@ ApplyWalRecord(XLogReaderState *xlogreader, XLogRecord *record, TimeLineID *repl
 		}
 		else if (info == XLOG_END_OF_RECOVERY)
 		{
-			xl_end_of_recovery xlrec;
+			xl_end_of_recovery xlrec = {0};
 
 			memcpy(&xlrec, XLogRecGetData(xlogreader), sizeof(xl_end_of_recovery));
 			newReplayTLI = xlrec.ThisTimeLineID;
@@ -2113,7 +2113,7 @@ xlogrecovery_redo(XLogReaderState *record, TimeLineID replayTLI)
 	if (info == XLOG_OVERWRITE_CONTRECORD)
 	{
 		/* Verify the payload of a XLOG_OVERWRITE_CONTRECORD record. */
-		xl_overwrite_contrecord xlrec;
+		xl_overwrite_contrecord xlrec = {0};
 
 		memcpy(&xlrec, XLogRecGetData(record), sizeof(xl_overwrite_contrecord));
 		if (xlrec.overwritten_lsn != record->overwrittenRecPtr)
diff --git a/src/backend/catalog/storage.c b/src/backend/catalog/storage.c
index e443a4993c5..f82fce1f929 100644
--- a/src/backend/catalog/storage.c
+++ b/src/backend/catalog/storage.c
@@ -186,7 +186,7 @@ RelationCreateStorage(RelFileLocator rlocator, char relpersistence,
 void
 log_smgrcreate(const RelFileLocator *rlocator, ForkNumber forkNum)
 {
-	xl_smgr_create xlrec;
+	xl_smgr_create xlrec = {0};
 
 	/*
 	 * Make an XLOG entry reporting the file creation.
@@ -391,7 +391,7 @@ RelationTruncate(Relation rel, BlockNumber nblocks)
 		 * Make an XLOG entry reporting the file truncation.
 		 */
 		XLogRecPtr	lsn;
-		xl_smgr_truncate xlrec;
+		xl_smgr_truncate xlrec = {0};
 
 		xlrec.blkno = nblocks;
 		xlrec.rlocator = rel->rd_locator;
diff --git a/src/backend/commands/dbcommands.c b/src/backend/commands/dbcommands.c
index 740c526e92d..42f3fd1c931 100644
--- a/src/backend/commands/dbcommands.c
+++ b/src/backend/commands/dbcommands.c
@@ -524,7 +524,7 @@ CreateDirAndVersionFile(char *dbpath, Oid dbid, Oid tsid, bool isRedo)
 	/* If we are not in WAL replay then write the WAL. */
 	if (!isRedo)
 	{
-		xl_dbase_create_wal_log_rec xlrec;
+		xl_dbase_create_wal_log_rec xlrec = {0};
 
 		START_CRIT_SECTION();
 
@@ -620,7 +620,7 @@ CreateDatabaseUsingFileCopy(Oid src_dboid, Oid dst_dboid, Oid src_tsid,
 
 		/* Record the filesystem change in XLOG */
 		{
-			xl_dbase_create_file_copy_rec xlrec;
+			xl_dbase_create_file_copy_rec xlrec = {0};
 
 			xlrec.db_id = dst_dboid;
 			xlrec.tablespace_id = dsttablespace;
@@ -2215,7 +2215,7 @@ movedb(const char *dbname, const char *tblspcname)
 		 * Record the filesystem change in XLOG
 		 */
 		{
-			xl_dbase_create_file_copy_rec xlrec;
+			xl_dbase_create_file_copy_rec xlrec = {0};
 
 			xlrec.db_id = db_id;
 			xlrec.tablespace_id = dst_tblspcoid;
@@ -2313,7 +2313,7 @@ movedb(const char *dbname, const char *tblspcname)
 	 * Record the filesystem change in XLOG
 	 */
 	{
-		xl_dbase_drop_rec xlrec;
+		xl_dbase_drop_rec xlrec = {0};
 
 		xlrec.db_id = db_id;
 		xlrec.ntablespaces = 1;
@@ -3072,7 +3072,7 @@ remove_dbtablespaces(Oid db_id)
 
 	/* Record the filesystem change in XLOG */
 	{
-		xl_dbase_drop_rec xlrec;
+		xl_dbase_drop_rec xlrec = {0};
 
 		xlrec.db_id = db_id;
 		xlrec.ntablespaces = ntblspc;
diff --git a/src/backend/commands/sequence.c b/src/backend/commands/sequence.c
index e1b808bbb60..f59be766238 100644
--- a/src/backend/commands/sequence.c
+++ b/src/backend/commands/sequence.c
@@ -399,7 +399,7 @@ fill_seq_fork_with_data(Relation rel, HeapTuple tuple, ForkNumber forkNum)
 	/* XLOG stuff */
 	if (RelationNeedsWAL(rel) || forkNum == INIT_FORKNUM)
 	{
-		xl_seq_rec	xlrec;
+		xl_seq_rec	xlrec = {0};
 		XLogRecPtr	recptr;
 
 		XLogBeginInsert();
@@ -408,7 +408,7 @@ fill_seq_fork_with_data(Relation rel, HeapTuple tuple, ForkNumber forkNum)
 		xlrec.locator = rel->rd_locator;
 
 		XLogRegisterData(&xlrec, sizeof(xl_seq_rec));
-		XLogRegisterData(tuple->t_data, tuple->t_len);
+		XLogRegisterData((char *) tuple->t_data, tuple->t_len);
 
 		recptr = XLogInsert(RM_SEQ_ID, XLOG_SEQ_LOG);
 
@@ -822,7 +822,7 @@ nextval_internal(Oid relid, bool check_permissions)
 	/* XLOG stuff */
 	if (logit && RelationNeedsWAL(seqrel))
 	{
-		xl_seq_rec	xlrec;
+		xl_seq_rec	xlrec = {0};
 		XLogRecPtr	recptr;
 
 		/*
@@ -842,7 +842,7 @@ nextval_internal(Oid relid, bool check_permissions)
 		xlrec.locator = seqrel->rd_locator;
 
 		XLogRegisterData(&xlrec, sizeof(xl_seq_rec));
-		XLogRegisterData(seqdatatuple.t_data, seqdatatuple.t_len);
+		XLogRegisterData((char *) seqdatatuple.t_data, seqdatatuple.t_len);
 
 		recptr = XLogInsert(RM_SEQ_ID, XLOG_SEQ_LOG);
 
@@ -1019,7 +1019,7 @@ SetSequence(Oid relid, int64 next, bool iscalled)
 	/* XLOG stuff */
 	if (RelationNeedsWAL(seqrel))
 	{
-		xl_seq_rec	xlrec;
+		xl_seq_rec	xlrec = {0};
 		XLogRecPtr	recptr;
 		Page		page = BufferGetPage(buf);
 
@@ -1028,7 +1028,7 @@ SetSequence(Oid relid, int64 next, bool iscalled)
 
 		xlrec.locator = seqrel->rd_locator;
 		XLogRegisterData(&xlrec, sizeof(xl_seq_rec));
-		XLogRegisterData(seqdatatuple.t_data, seqdatatuple.t_len);
+		XLogRegisterData((char *) seqdatatuple.t_data, seqdatatuple.t_len);
 
 		recptr = XLogInsert(RM_SEQ_ID, XLOG_SEQ_LOG);
 
diff --git a/src/backend/commands/tablecmds.c b/src/backend/commands/tablecmds.c
index b04b0dbd2a0..f04d647186c 100644
--- a/src/backend/commands/tablecmds.c
+++ b/src/backend/commands/tablecmds.c
@@ -2307,7 +2307,7 @@ ExecuteTruncateGuts(List *explicit_rels,
 	 */
 	if (relids_logged != NIL)
 	{
-		xl_heap_truncate xlrec;
+		xl_heap_truncate xlrec = {0};
 		int			i = 0;
 
 		/* should only get here if effective_wal_level is 'logical' */
diff --git a/src/backend/commands/tablespace.c b/src/backend/commands/tablespace.c
index ed2a93a09db..fca45c5137a 100644
--- a/src/backend/commands/tablespace.c
+++ b/src/backend/commands/tablespace.c
@@ -365,7 +365,7 @@ CreateTableSpace(CreateTableSpaceStmt *stmt)
 
 	/* Record the filesystem change in XLOG */
 	{
-		xl_tblspc_create_rec xlrec;
+		xl_tblspc_create_rec xlrec = {0};
 
 		xlrec.ts_id = tablespaceoid;
 
@@ -535,7 +535,7 @@ DropTableSpace(DropTableSpaceStmt *stmt)
 
 	/* Record the filesystem change in XLOG */
 	{
-		xl_tblspc_drop_rec xlrec;
+		xl_tblspc_drop_rec xlrec = {0};
 
 		xlrec.ts_id = tablespaceoid;
 
diff --git a/src/backend/postmaster/walsummarizer.c b/src/backend/postmaster/walsummarizer.c
index 742137edad6..e0eb2bea0f1 100644
--- a/src/backend/postmaster/walsummarizer.c
+++ b/src/backend/postmaster/walsummarizer.c
@@ -1431,7 +1431,7 @@ SummarizeXlogRecord(XLogReaderState *xlogreader, bool *new_fast_forward)
 	}
 	else if (info == XLOG_CHECKPOINT_SHUTDOWN)
 	{
-		CheckPoint	rec_ckpt;
+		CheckPoint	rec_ckpt = {0};
 
 		/* Extract wal_level at time record was written from payload. */
 		memcpy(&rec_ckpt, XLogRecGetData(xlogreader), sizeof(CheckPoint));
@@ -1439,7 +1439,7 @@ SummarizeXlogRecord(XLogReaderState *xlogreader, bool *new_fast_forward)
 	}
 	else if (info == XLOG_PARAMETER_CHANGE)
 	{
-		xl_parameter_change xlrec;
+		xl_parameter_change xlrec = {0};
 
 		/* Extract wal_level at time record was written from payload. */
 		memcpy(&xlrec, XLogRecGetData(xlogreader),
@@ -1448,7 +1448,7 @@ SummarizeXlogRecord(XLogReaderState *xlogreader, bool *new_fast_forward)
 	}
 	else if (info == XLOG_END_OF_RECOVERY)
 	{
-		xl_end_of_recovery xlrec;
+		xl_end_of_recovery xlrec = {0};
 
 		/* Extract wal_level at time record was written from payload. */
 		memcpy(&xlrec, XLogRecGetData(xlogreader), sizeof(xl_end_of_recovery));
diff --git a/src/backend/replication/logical/decode.c b/src/backend/replication/logical/decode.c
index 21f03864a66..867cf9d0158 100644
--- a/src/backend/replication/logical/decode.c
+++ b/src/backend/replication/logical/decode.c
@@ -1245,7 +1245,7 @@ DecodeSpecConfirm(LogicalDecodingContext *ctx, XLogRecordBuffer *buf)
 static void
 DecodeXLogTuple(char *data, Size len, HeapTuple tuple)
 {
-	xl_heap_header xlhdr;
+	xl_heap_header xlhdr = {0};
 	int			datalen = len - SizeOfHeapHeader;
 	HeapTupleHeader header;
 
diff --git a/src/backend/replication/logical/message.c b/src/backend/replication/logical/message.c
index 06825d66e7f..5a165c591cb 100644
--- a/src/backend/replication/logical/message.c
+++ b/src/backend/replication/logical/message.c
@@ -43,7 +43,7 @@ XLogRecPtr
 LogLogicalMessage(const char *prefix, const char *message, size_t size,
 				  bool transactional, bool flush)
 {
-	xl_logical_message xlrec;
+	xl_logical_message xlrec = {0};
 	XLogRecPtr	lsn;
 
 	/*
diff --git a/src/backend/replication/logical/origin.c b/src/backend/replication/logical/origin.c
index c3271a6fd0e..3a3dee4c411 100644
--- a/src/backend/replication/logical/origin.c
+++ b/src/backend/replication/logical/origin.c
@@ -419,7 +419,7 @@ restart:
 
 			/* first make a WAL log entry */
 			{
-				xl_replorigin_drop xlrec;
+				xl_replorigin_drop xlrec = {0};
 
 				xlrec.node_id = roident;
 				XLogBeginInsert();
@@ -1008,7 +1008,7 @@ replorigin_advance(ReplOriginId node,
 	 */
 	if (wal_log)
 	{
-		xl_replorigin_set xlrec;
+		xl_replorigin_set xlrec = {0};
 
 		xlrec.remote_lsn = remote_commit;
 		xlrec.node_id = node;
diff --git a/src/backend/storage/ipc/standby.c b/src/backend/storage/ipc/standby.c
index d83afbfb9d6..6b950fbab86 100644
--- a/src/backend/storage/ipc/standby.c
+++ b/src/backend/storage/ipc/standby.c
@@ -987,7 +987,7 @@ StandbyAcquireAccessExclusiveLock(TransactionId xid, Oid dbOid, Oid relOid)
 {
 	RecoveryLockXidEntry *xidentry;
 	RecoveryLockEntry *lockentry;
-	xl_standby_lock key;
+	xl_standby_lock key = {0};
 	LOCKTAG		locktag;
 	bool		found;
 
@@ -1353,7 +1353,7 @@ LogStandbySnapshot(void)
 static XLogRecPtr
 LogCurrentRunningXacts(RunningTransactions CurrRunningXacts)
 {
-	xl_running_xacts xlrec;
+	xl_running_xacts xlrec = {0};
 	XLogRecPtr	recptr;
 
 	xlrec.xcnt = CurrRunningXacts->xcnt;
@@ -1413,7 +1413,7 @@ LogCurrentRunningXacts(RunningTransactions CurrRunningXacts)
 static void
 LogAccessExclusiveLocks(int nlocks, xl_standby_lock *locks)
 {
-	xl_standby_locks xlrec;
+	xl_standby_locks xlrec = {0};
 
 	xlrec.nlocks = nlocks;
 
@@ -1431,7 +1431,7 @@ LogAccessExclusiveLocks(int nlocks, xl_standby_lock *locks)
 void
 LogAccessExclusiveLock(Oid dbOid, Oid relOid)
 {
-	xl_standby_lock xlrec;
+	xl_standby_lock xlrec = {0};
 
 	xlrec.xid = GetCurrentTransactionId();
 
@@ -1471,10 +1471,8 @@ void
 LogStandbyInvalidations(int nmsgs, SharedInvalidationMessage *msgs,
 						bool relcacheInitFileInval)
 {
-	xl_invalidations xlrec;
+	xl_invalidations xlrec = {0};
 
-	/* prepare record */
-	memset(&xlrec, 0, sizeof(xlrec));
 	xlrec.dbId = MyDatabaseId;
 	xlrec.tsId = MyDatabaseTableSpace;
 	xlrec.relcacheInitFileInval = relcacheInitFileInval;
@@ -1483,7 +1481,7 @@ LogStandbyInvalidations(int nmsgs, SharedInvalidationMessage *msgs,
 	/* perform insertion */
 	XLogBeginInsert();
 	XLogRegisterData(&xlrec, MinSizeOfInvalidations);
-	XLogRegisterData(msgs,
+	XLogRegisterData((char *) msgs,
 					 nmsgs * sizeof(SharedInvalidationMessage));
 	XLogInsert(RM_STANDBY_ID, XLOG_INVALIDATIONS);
 }
diff --git a/src/backend/utils/cache/inval.c b/src/backend/utils/cache/inval.c
index d59216b28f1..389b493e21b 100644
--- a/src/backend/utils/cache/inval.c
+++ b/src/backend/utils/cache/inval.c
@@ -1938,7 +1938,7 @@ CallRelSyncCallbacks(Oid relid)
 void
 LogLogicalInvalidations(void)
 {
-	xl_xact_invals xlrec;
+	xl_xact_invals xlrec = {0};
 	InvalidationMsgsGroup *group;
 	int			nmsgs;
 
@@ -1959,10 +1959,10 @@ LogLogicalInvalidations(void)
 		XLogBeginInsert();
 		XLogRegisterData(&xlrec, MinSizeOfXactInvals);
 		ProcessMessageSubGroupMulti(group, CatCacheMsgs,
-									XLogRegisterData(msgs,
+									XLogRegisterData((char *) msgs,
 													 n * sizeof(SharedInvalidationMessage)));
 		ProcessMessageSubGroupMulti(group, RelCacheMsgs,
-									XLogRegisterData(msgs,
+									XLogRegisterData((char *) msgs,
 													 n * sizeof(SharedInvalidationMessage)));
 		XLogInsert(RM_XACT_ID, XLOG_XACT_INVALIDATIONS);
 	}
diff --git a/src/backend/utils/cache/relmapper.c b/src/backend/utils/cache/relmapper.c
index 778b14a2318..896c153bf87 100644
--- a/src/backend/utils/cache/relmapper.c
+++ b/src/backend/utils/cache/relmapper.c
@@ -86,7 +86,7 @@ typedef struct RelMapping
 	RelFileNumber mapfilenumber;	/* its rel file number */
 } RelMapping;
 
-typedef struct RelMapFile
+typedef struct PG_NO_PADDING RelMapFile
 {
 	int32		magic;			/* always RELMAPPER_FILEMAGIC */
 	int32		num_mappings;	/* number of valid RelMapping entries */
@@ -264,7 +264,7 @@ RelationMapFilenumberToOid(RelFileNumber filenumber, bool shared)
 RelFileNumber
 RelationMapOidToFilenumberForDatabase(char *dbpath, Oid relationId)
 {
-	RelMapFile	map;
+	RelMapFile	map = {0};
 	int			i;
 
 	/* Read the relmap file from the source database. */
@@ -291,7 +291,7 @@ RelationMapOidToFilenumberForDatabase(char *dbpath, Oid relationId)
 void
 RelationMapCopy(Oid dbid, Oid tsid, char *srcdbpath, char *dstdbpath)
 {
-	RelMapFile	map;
+	RelMapFile	map = {0};
 
 	/*
 	 * Read the relmap file from the source database.
@@ -958,7 +958,7 @@ write_relmap_file(RelMapFile *newmap, bool write_wal, bool send_sinval,
 
 	if (write_wal)
 	{
-		xl_relmap_update xlrec;
+		xl_relmap_update xlrec = {0};
 		XLogRecPtr	lsn;
 
 		/* now errors are fatal ... */
@@ -1038,7 +1038,7 @@ write_relmap_file(RelMapFile *newmap, bool write_wal, bool send_sinval,
 static void
 perform_relmap_update(bool shared, const RelMapFile *updates)
 {
-	RelMapFile	newmap;
+	RelMapFile	newmap = {0};
 
 	/*
 	 * Anyone updating a relation's mapping info should take exclusive lock on
@@ -1103,7 +1103,7 @@ relmap_redo(XLogReaderState *record)
 	if (info == XLOG_RELMAP_UPDATE)
 	{
 		xl_relmap_update *xlrec = (xl_relmap_update *) XLogRecGetData(record);
-		RelMapFile	newmap;
+		RelMapFile	newmap = {0};
 		char	   *dbpath;
 
 		if (xlrec->nbytes != sizeof(RelMapFile))
diff --git a/src/bin/pg_resetwal/pg_resetwal.c b/src/bin/pg_resetwal/pg_resetwal.c
index ab766c34d4b..04a7168240a 100644
--- a/src/bin/pg_resetwal/pg_resetwal.c
+++ b/src/bin/pg_resetwal/pg_resetwal.c
@@ -1152,6 +1152,7 @@ WriteEmptyXLOG(void)
 	/* Insert the initial checkpoint record */
 	recptr = (char *) page + SizeOfXLogLongPHD;
 	record = (XLogRecord *) recptr;
+	memset(record, 0, SizeOfXLogRecord);
 	record->xl_prev = InvalidXLogRecPtr;
 	record->xl_xid = InvalidTransactionId;
 	record->xl_tot_len = SizeOfXLogRecord + SizeOfXLogRecordDataHeaderShort + sizeof(CheckPoint);
